﻿var air;

(function(){
	
if(typeof air=='undefined') air = {};

air.tcAgent = {

	runtime: {

		window: window,
		nativeApplication: window.runtime.flash.desktop.NativeApplication.nativeApplication
	},

	init: function() {

		var connection = new this.runtime.window.runtime.flash.net.LocalConnection();
		connection.client = this;
		connection.allowDomain('*');
		connection.connect("_tcaAgent." + this.runtime.nativeApplication.applicationID);
		this.connection = connection;

	},

	tcaVersion: function(){ 

		return 3;
	},

	getIsHTMLLoader: function (obj) {

		var className = runtime.flash.utils.getQualifiedClassName(obj);
		return (className == "flash.html::HTMLLoader") ||
			(className == "mx.core::FlexHTMLLoader");
	},


	findLoader: function(obj) {

		if (this.getIsHTMLLoader(obj)) {
			return obj;
		} else {

			try{
				if (typeof obj.numChildren != 'undefined')
				{
		        		for(var i = 0; i < obj.numChildren; i++)
					{
				        	var child = obj.getChildAt(i);
						if (this.getIsHTMLLoader(child))
							return child;

						var loader = this.findLoader(child);
						if (loader != null)
							return loader;
				        }
				}
			} catch(e){
			}
		}

		return null;
		
	},

	escapeCR: function(str) {

		var array = str.split("\n");
		return array.join(" ");
	},

	getObjectData: function(obj) {

		return this.getObjectDataInt(obj, true);
	},

	isItemNative: function(obj) {

       		try{
    		       return (typeof(obj.item) != "undefined" && obj.item.toString().indexOf("[native code]")>0);
		}catch(e){
       		}
       		return false;
	},

	isArrayObject: function(obj){

		try{
			if (typeof(obj.length) != "number")
				return false;
			for(var i in obj)
			{
				if (i == "length") 
					continue;
				var n = parseInt(i, 10);
				if (!isNaN(n) && (n >= 0) && (n < obj.length)) 
					continue;
				if (typeof(obj[i]) == "function")
					continue;
				return false;
			}
			return true;
		}catch(e){
       		}
		return false;
	},

	getNodeName: function(obj) {

		var nodeName = typeof(obj.nodeName) == "string" ?  obj.nodeName.toUpperCase(): "Object";

		if (nodeName == "INPUT")
		{
			var typeValue = obj["type"];
			if (typeof(typeValue) == "string")
				nodeName = typeValue.toUpperCase();
		}
		return nodeName;
	},

	getObjectDataInt: function(obj, addProps) {

		var objType = typeof obj;

		switch (objType) {
		case "boolean":
			{
				var str = "11:" + obj.toString();
				return str;
			}
		case "number":
			{
				var str = "5:" + obj.toString();
				return str;
			}
		case "string":
			{
				var str = "8:\"" + this.escapeCR(obj) + "\"";
				return str;
			}

		case "object":
			{
				var str = "";

				var isArray = false;
				var className = runtime.flash.utils.getQualifiedClassName(obj);
				if (className == "flash.html::__HTMLScriptObject") 
				{
					className = this.getNodeName(obj);
					isArray = this.isArrayObject(obj);
				} 

				if (!isArray)
					str = "9:(" + className + ")";
				else
					str = "8192:(Array)";
				if (!addProps)
					return str;

				str += "<";


				if (isArray)
				{
					for(var i = 0; i < obj.length; i++)
					{
	        				var value;
	       					try {
		      					value = obj[i];
	       					}catch(e){
							value = e;
	       					}
			
						if (typeof value == "function") continue;

						str += "\n" + i.toString() + "=";
		                        	try
	               		        	{
	                       				str += this.getObjectDataInt(value, false);
				                }	
				                catch(e)
				                {
				                	str += "12:null";
				                }
	    			        }
				} else {


					for(var i in obj)
					{
	                			var n = parseInt(i, 10);
						if (!isNaN(n)) continue;
						if (i == i.toString().toUpperCase()) continue;

	        				var value;
	       					try {
		      					value = obj[i];
	       					}catch(e){
							value = e;
	       					}
			
						if (typeof value == "function") continue;

						str += "\n" + i.toString() + "=";
		                        	try
	               		        	{
	                       				str += this.getObjectDataInt(value, false);
				                }	
				                catch(e)
				                {
				                	str += "12:null";
				                }
	    			        }
				}

				var typeDescription = runtime.flash.utils.describeType(obj);
				var domParser = new DOMParser();
				var typeXml = domParser.parseFromString(typeDescription, "text/xml");
				var child = typeXml.firstChild.firstChild;
				while(child)
				{
					if(child.nodeName=='accessor'||child.nodeName=='variable')
					{
						var propName = child.getAttribute('name');
						if (propName != null && propName != 'prototype')
						{
                        				str += "\n" + propName + "=";
		                        		try
                		        		{
                            					str += this.getObjectDataInt(obj[propName], false);
				                        }	
				                        catch(e)
				                        {
				                            str += "12:null";
				                        }
						}
					}
					child = child.nextSibling;
				}
				str += ">";

				return str;
			}
		default:
			return "12:null";
		};
		return "";

	},

	getDocument: function(obj) {

		if (obj.document != null)
		  return obj.document;
		var loader = this.findLoader(obj);
		return loader != null ? loader.window.document: null;
		
	},

	getObjectByPath: function(path)	{

	   try {
	
		if ((path == "") || (path == "\\"))
			return null;
			
		var parentPath = "";
		var name = path;
		var dotDelimiter = false;
		var dotPos = path.lastIndexOf(".");
		var slashPos = path.lastIndexOf("\\");
		var lastDelim = -1;

		if (dotPos > slashPos)
		{
			lastDelim = dotPos;
			dotDelimiter = true;
		} else {
			lastDelim = slashPos;
		}

		if (lastDelim != -1)
		{
			parentPath = path.slice(0, lastDelim);
			name = path.slice(lastDelim + 1); 			
		}
		
		var parentObject = this.getObjectByPath(parentPath);
		if (parentObject == null)
			return this.runtime.nativeApplication.openedWindows[name];

		if (!dotDelimiter)
		{
			var container = parentObject;
			if (name == "*")
				return container.getChildAt(0);

			try {

				if (typeof container.numChildren != 'undefined')
				{
					var document = this.getDocument(container);
					if (document == null)
						return null;
					container = document.body;
				}
			} catch(e) {
			}

			var indexes = new Array();
			var item = container.firstChild;

			while (item != null)
			{
				if (item.nodeName == "#text")
				{
					item = item.nextSibling;
					continue;
				}
				var itemName = item.id;
				if (itemName == null || itemName == "")
					itemName = this.getNodeName(item);

				while (true)
				{
					var itemIndex = indexes[itemName] != null ? indexes[itemName] + 1: 1;
					indexes[itemName] = itemIndex;
					if (itemIndex == 1)
						break;
					itemName = itemName + itemIndex.toString();
				}
				if (itemName == name)
					return item;
				item = item.nextSibling;
			}


			return null;

		} else {

			return parentObject[name];
		}

		return null;
	   } catch(e) {

	   }
	   return null;
	},

	tcaGetChildren: function(path) {

		var names = "";

		try {
			var container = this.getObjectByPath(path);
			if (container == null)
				return names;

			try {

				if (typeof container.numChildren != 'undefined')
				{
					var document = this.getDocument(container);
					if (document == null)
						return null;
					container = document.body;
				}
			} catch(e) {
			}

			var indexes = {};
			var item = container.firstChild;
			if (name == "*")
				return item;


			while (item != null)
			{
				if (item.nodeName == "#text")
				{
					item = item.nextSibling;
					continue;
				}

				var itemId = item.id != null ? item.id: "";
				var itemName = itemId;
				var nodeName = this.getNodeName(item);
				if (itemName == "")
					itemName = nodeName;
				
				while (true)
				{
					var itemIndex = indexes[itemName] != null ? indexes[itemName] + 1: 1;
					indexes[itemName] = itemIndex;
					if (itemIndex == 1)
						break;
					itemName = itemName + itemIndex.toString();
				}

				var childName = itemId + ",HTML::" + nodeName + "," + itemName;
				if (names != "")
				  names += "\n";
				names += childName;		

				item = item.nextSibling;
			}

		} catch(e) {
		}
	
		return names;
	},

		
	tcaGetObject: function(path) {

		var obj = this.getObjectByPath(path);
		if (obj == null)
			return "";
			
		return this.getObjectData(obj);
	},

	getObjectIsFocused: function(obj) {

		if (obj == null)
			return false;

		try {
			var focusManager = obj["focusManager"];
			if (focusManager == null)
				return false;

			return focusManager.getFocus() == obj;
		} catch(e) {
		}
		return false;
	},

	getStyleProp: function(element, prop)
            {
                var value;
                try
                {
                    if (element.style)
                        value = element.style[prop];
            
                    if (!value && element.currentStyle)
                        value = element.currentStyle[prop];
                }
                catch (e) {}
            
                return value == 'auto' ? null: value;
        },

	getIntProp: function(element, prop) {
                var a = parseInt(this.getStyleProp(element, prop), 10);
                if (isNaN(a))
                    return 0;
                return a;
        },

	getBorderBox: function (element) {

                var doc = element.ownerDocument;
            
                if (element.parentNode === null || this.getStyleProp(element, 'display') == 'none') {
                    return false;
                }
            
                var ret = {x:0, y:0, width:0, height:0};
                var parent = null;
                var box;

                ret.x = element.offsetLeft;
                ret.y = element.offsetTop;
                ret.width = element.offsetWidth;
                ret.height = element.offsetHeight;

		parent = element.offsetParent;

                if (parent != element) {
                    while (parent) {
                        ret.x += parent.offsetLeft;
                        ret.y += parent.offsetTop;
                        ret.x += this.getIntProp(parent, "borderLeftWidth");
                        ret.y += this.getIntProp(parent, "borderTopWidth");                        
                        parent = parent.offsetParent;
                    }
                }

                switch (this.getStyleProp(element, 'position'))
		{
 		case 'absolute':
                   	ret.y -= doc.body.offsetTop;
			break;
		case 'fixed':
	                ret.y += doc.body.scrollTop;
	                ret.x += doc.body.scrollLeft;
			break;
		};
                    
                if (element.parentNode)
                    parent = element.parentNode;
                else
                    parent = null;
                
		if (parent != null && parent.nodeName)
		{
                    var cas = parent.nodeName.toUpperCase();
                    while (parent && cas != 'HTML') {
                        cas = parent.nodeName.toUpperCase();
                        ret.x -= parent.scrollLeft;
                        ret.y -= parent.scrollTop;
                        if (parent.parentNode)
                            parent = parent.parentNode;
                        else
                            parent = null;
                    }
                }

                // adjust the margin
                var btw = this.getIntProp(element, "marginTop");
                var blw = this.getIntProp(element, "marginLeft");
                var bbw = this.getIntProp(element, "marginBottom");
                var brw = this.getIntProp(element, "marginRight");
                ret.x -= blw;
                ret.y -= btw;
                ret.height += btw + bbw;
                ret.width += blw + brw;

                return ret;
        },

	tcaGetControlInfo: function(path) {

		var control = this.getObjectByPath(path);
		if (control == null)
			return "";
		
		var htmlControl = runtime.flash.utils.getQualifiedClassName(control) == "flash.html::__HTMLScriptObject";
		try {
			var obj = {};

			if (!htmlControl)
			{			
				obj["visible"] = control.visible;
				obj["enabled"] = control.enabled;
				obj["focused"] = getObjectIsFocused(control);
				obj["x"] = control.x;
				obj["y"] = control.y;
				obj["height"] = control.height;
				obj["width"] = control.width;
				var point = control.localToGlobal(new Point(0, 0));
				obj["offsetLeft"] = point.x;
				obj["offsetTop"] = point.y;
			} else {

				var rect = this.getBorderBox(control);
				obj["visible"] = (rect.width != 0) && (rect.height != 0); 
				obj["enabled"] = (typeof(control.disabled) == "undefined") || (control.disabled == false);
				obj["focused"] = control.ownerDocument.activeElement == control;
				obj["x"] = rect.x;
				obj["y"] = rect.y;
				obj["height"] = rect.height;
				obj["width"] = rect.width;
				obj["offsetLeft"] = rect.x;
				obj["offsetTop"] = rect.y;
			}
			obj["controltype"] = "";

		} catch(e) {
		}
			
		return this.getObjectData(obj);
	},
	
	tcaGetObjectExist: function(path) {
		
		var obj = this.getObjectByPath(path);
		if (obj == null)
			return false;
		return true;		
	},
		
	tcaSetObjectProperty: function(path, propName, value) {

		var obj = this.getObjectByPath(path);
		if (obj == null)
			return;

		try {
			obj[propName] = value;				 
		} catch(e) {
		}
	},
		
	tcaGetObjectProperty: function(path, propName) {

		var obj = this.getObjectByPath(path);
		if (obj == null)
			return "";

		try {
			var prop = obj[propName];
			return this.getObjectData(prop);
		} catch(e) {
		}
		return null;
	},

	tcaInvokeObjectMethod: function(path, name, args) {

		var obj = this.getObjectByPath(path);
		if (obj == null)
			return null;

		try {
			return obj[name].apply(obj, args);
		} catch(e) {
		}
		return null;
	},


			
	tcaSetFocus: function(path) {

		var obj = this.getObjectByPath(path);
		if (obj == null)
			return;

		try {
			obj.focus();
		} catch(e) {
		}
	},

	tcaGetClassHierarchy: function(path) {

		return "";
	},
	
	tcaFindWindow: function(x, y, width, height) {


		var windows = this.runtime.nativeApplication.openedWindows;			
		for (var i = 0; i < windows.length; i++)
		{
			var window = windows[i];
			if ((window.x != x) || (window.y != y) || (window.width != width) || (window.height != height))
				continue;
	
			return "." + i.toString();
		}
		return "";
	},

	tcaInvokeMethod: function (callback, methodName, args)	{

		var retVal;

		try
		{
			retVal = air.tcAgent[methodName].apply(air.tcAgent, args);
		} catch(e) {
		}

		try {
			var callbackConnection = new window.runtime.flash.net.LocalConnection();
			callbackConnection.send(callback, "nevermind", retVal);
		} catch(e) {
		}
	}

};

air.tcAgent.init();
	
})();