﻿function Project(obj) {
    var self = this;

    self.projectId;
    self.projectName;
    self.projectDesc;
    self.assignmentId; //AC removed projectClassAcctId and added assignmentId
    self.dateLastModified;
    self.studentLogin;
    self.projectQuest;

    self.items; //AC added
    self.teams; //AC added
    self.comments; //AC added

    self.isNew = false;

    //initialize with passed in objects values
    for (var prop in obj) this[prop] = obj[prop];

    self.updateItemOrder = function () {
        var position = 1,
            id,
            newItems = new Array();

        // go through list and assign a unique index to each item
        $("#main-list").find('li').each(function () {
            id = $(this).attr('id').replace("main-", '');

            for (var i = 0, len = self.items.length; i < len; i++) {
                if (self.items[i].itemId == id) {
                    self.items[i].position = position;
                    newItems.push(self.items[i]);
                    break;
                }
            }
            position++;
        });

        self.items = newItems;
        newItems = null;

//        if (compareTeamID != "") {
//            methods.updateLines();
//            methods.calculateCorrelation();
//        }

    };

    //checks stored validation for THIS project returns true false
    self.load = function () {
        //clear these down before load, json wont propperly transfer (bad request 400 error)
        self.teams = null;
        self.items = null;
        self.comments = null;

        $.ajax({
            type: 'POST',
            url: WSURL + '/Project/' + self.projectId,
            contentType: 'application/json; charset=utf-8',
            datatype: 'json',
            async: true,
            cache: false,
            data: $.toJSON(self),
            timeout: connectionTimeout,
            complete: function(){p.hideLoading();},
            success: function (data) {
                if (data.IsError) {
                } else {
                    tempProj = data.Project;
                    //var temp = new Project(data.Project);
                    //for (var prop in temp) self[prop] = temp[prop];
                    $(document).trigger('projLoadSuccess');
                }
            }
        });
    };

    self.save = function () {
        if (isDirty) {
            var tempImageData = {};
            var tempTeamData = [];
            for (var i = 0, len = self.items.length; i < len; i++) {
                tempImageData[i] = {};
                tempImageData[i].imageData = self.items[i].imageData;
               
                self.items[i].imageData = null; //Removing imageData to cut down on data transfer and workaround for modelbinding error
                tempImageData.length = i + 1;
            }

            for (var i = 0, len = self.teams.length; i < len; i++) {
                tempTeamData[i] = self.teams[i];
            }
            self.teams = [];

            $.ajax({
                type: 'POST',
                url: WSURL + '/Project/Save/' + self.projectId,
                contentType: 'application/json; charset=utf-8',
                datatype: 'json',
                //async: false,
                data: $.toJSON(self),
                success: function (data) {
                    if (data.IsError) {
                        jAlert("Invalid login details entered", "Visual Ranking App - Error");
                    } else {
                        //modified by vara- 29 oct 2013 for localization -start
                        //jAlert("Data saved successfully", "Visual Ranking App - Save Success");


                        jAlert(getRsc('rsc_26'), getRsc('rsc_27'));
                        // $("#popup_message").css('font-size', '14px', 'important');
                        //end
                    }
                }
            });

            //re-add image data

            for (var i = 0, len = tempImageData.length; i < len; i++) {
                self.items[i].imageData = tempImageData[i].imageData;
            }
            for (var i = 0, len = tempTeamData.length; i < len; i++) {
                self.teams[i] = tempTeamData[i];
            }
        }
        else {
            jAlert(getRsc('rsc_26'), getRsc('rsc_27'));
        }
    };

    self.getItemsOrder = function (teamId) {
        var copy = new Project();
        copy.projectId = self.projectId;
        copy.studentLogin = self.studentLogin;

        var passback = null;
        $.ajax({
            type: 'POST',
            url: WSURL + '/ItemOrder/' + teamId,
            contentType: 'application/json; charset=utf-8',
            datatype: 'json',
            data: $.toJSON(copy),
            async: false,
            success: function (data) {
                if (data.IsError) {
                    jAlert(data.Message, "Visual Ranking App - Error"); ;
                }
                else {
                    passback = data.ItemOrders;
                }
            }
        });
        return passback;
    };

    self.addComment = function (comment) {
        if (self.comments == null || self.comments == undefined) {
            self.comments = [];
        }
        var newComment = new Comment(comment, self.assignmentId);
        self.comments.push(newComment);
        if ($('#noComments').length != 0) {
            $('#noComments').remove();
        }
        //temp set the comment source name for display purposes & local date
        //this value wont be saved to the db.
        //newComment.source = self.studentLogin.Team;
        //newComment.date = " (not yet saved)";
        var tempComment = new Comment(comment, self.assignmentId);
        tempComment.source = self.studentLogin.Team;
        tempComment.date = " ";
        $.tmpl("commentTemplate", tempComment).appendTo("#comments > ul");
    };

    self.calculateCorrelation = function (compareItems) {
        if ((compareItems.length != 0)) {
            var sigmaX = sigmaY = sigmaXY = sigmaX2 = sigmaY2 = 0;
            var n = compareItems.length;
            for (var i = 0; i < compareItems.length; i++) {
                sigmaX += self.items[i].position;
                sigmaY += compareItems[i].position;
                sigmaXY += (self.items[i].position * compareItems[i].position);
                sigmaX2 += (self.items[i].position * self.items[i].position);
                sigmaY2 += (compareItems[i].position * compareItems[i].position);
            }
            // [     NΣXY - (ΣX)(ΣY) / Sqrt([NΣX2 - (ΣX)2][NΣY2 - (ΣY)2])        ]
            var correlation = (((n * sigmaXY) - (sigmaX * sigmaY)) / (Math.sqrt(Math.floor((n * sigmaX2)
                - (sigmaX * sigmaX)) * Math.floor((n * sigmaY2) - (sigmaY * sigmaY)))));

//            var n = self.items.length;
//            var xi = new Array(),
//                    yi = new Array(),
//                    di = new Array(),
//                    di2 = new Array(),
//                    di2_total = 0,
//                    rho = 0, rho_string, i, id, msg;

//            //HACK - refine later, doesnt deal with same-ranked items
//            for (i = 0; i < compareItems.length; i++) {
//                compareItems[i].position = i + 1;
//            }

//            for (i = 0; i < n; i++) {
//                id = self.items[i].itemId;
//                var compareItem = findById(compareItems, 'itemId', id)
//                // indices start from 0, positioning should start at 1
//                xi[i] = self.items[i].position;
//                yi[i] = compareItem.position;
//            }

//            // rank the main list items
//            for (i = 0; i < n; i++) {
//                di[i] = xi[i] - yi[i];
//                di2[i] = di[i] * di[i];
//                di2_total += di2[i];
//            }

//            rho = 1 - (6 * di2_total) / (n * (n * n - 1));

            // round to 2 decimal places
            correlation = Math.round(correlation * 100) / 100;
            correlation_string = correlation.toString();

            // put in extra zeros
            if (correlation < 0) {
                // -1 => -1.00
                if (correlation_string.length == 2) {
                    correlation_string += ".00";
                }
                // -0.1 => -0.10
                else if (correlation_string.length == 4) {
                    correlation_string += "0";
                }
            }
            else {
                // 1 => 1.00
                if (correlation_string.length == 1) {
                    correlation_string += ".00";
                }
                // 0.1 => 0.10
                else if (correlation_string.length == 3) {
                    correlation_string += "0";
                }
            }

            //        if (-1 <= correlation && correlation <= -0.8) { msg = resourceData['correlation00']; }
            //        else if (-0.8 < correlation && correlation <= -0.6) { msg = resourceData['correlation01']; }
            //        else if (-0.6 < correlation && correlation <= -0.4) { msg = resourceData['correlation02']; }
            //        else if (-0.4 < correlation && correlation <= -0.2) { msg = resourceData['correlation03']; }
            //        else if (-0.2 < correlation && correlation < 0) { msg = resourceData['correlation04']; }
            //        else if (0 <= correlation && correlation < 0.2) { msg = resourceData['correlation05']; }
            //        else if (0.2 <= correlation && correlation < 0.4) { msg = resourceData['correlation06']; }
            //        else if (0.4 <= correlation && correlation < 0.6) { msg = resourceData['correlation07']; }
            //        else if (0.6 <= correlation && correlation < 0.8) { msg = resourceData['correlation08']; }
            //        else if (0.8 <= correlation && correlation <= 1) { msg = resourceData['correlation09']; }

            var CORRELATION_TEXT = $(".correlation");
           
            CORRELATION_TEXT.empty();
            //modified by vara 24 dec 2013 start
           // CORRELATION_TEXT.html("Correlation: " + correlation_string);
            var text = $(".correlationText").text();
            CORRELATION_TEXT.html(text + ": " + correlation_string);
            //end
            CORRELATION_TEXT.show();
        }
    };

}