﻿function ProjectList() {
    var self = this;

    self.list = new Array();

    self.length = function () {
        return self.list.length;
    }

    //    self.getID = function (id) {
    //        return self.list[id];
    //    }

    self.removeAtIndex = function (pos) {
        self.list.splice(pos, 1);
    }

    self.add = function (project) {
        self.list.push(new Project(project));
    }

    self.load = function (loaded) {
        for (var i in loaded) {
            var p = new Project(loaded[i]);
            //if time since first login is greater than the retention period reset it and remove local password
            if ((new Date().getTime() - p.studentLogin.dateRetained) / 1000 > retentionPeriod) {
                p.studentLogin.dateRetained = null;
                p.studentLogin.isRetained = false;
                p.studentLogin.Password = "";
            }
            self.add(p);
        }
    }

    self.update = function (currentLogin, projectsFromLogin) {

        var existingProjects = new Array();

        for (var i = self.length() - 1; i >= 0; i--) {
            var p = self.list[i];
            if (currentLogin.Teacher == p.studentLogin.Teacher
            //project is a match
                && currentLogin.Team == p.studentLogin.Team) {
                existingProjects.push(p);
                self.removeAtIndex(i);
            }
            else {
                //project is not match
                //remove save memory
            }
        }
        self.list = new Array();
        for (var n in projectsFromLogin) {
            var np = projectsFromLogin[n];
            if (existingProjects.length == 0) {
                np.isNew = true;
            } else {
                for (var e in existingProjects) {
                    var ex = existingProjects[e];
                    if (np.projectId == ex.projectId) {
                        if (np.dateLastModified > ex.dateLastModified)
                            np.isNew = true;
                        else
                            np.isNew = ex.isNew;
                        break;
                    }
                }
            }
            self.add(np);
        }
        //save locally
        self.save();
    }

    //redundant
    //gets a COPY of the project from projectList  by id (indirect access)
    //Lenny: NOT REDUNDANT! - todo: tidy up naming conventions RE assignment && project, its messed up
    self.getProjById = function (projId, ASSIGNMENT) {
        for (var p in self.list) {
            var proj = self.list[p];
            if (proj.assignmentId == ASSIGNMENT) {
                return proj;
            }
        }
        return null;
    }

    //gets the index in projectList[] project by id (for direct access)
    self.getProjIndexById = function (projId, ASSIGNMENT) {
        for (var p in self.list) {
            var proj = self.list[p];
            if (proj.assignmentId == ASSIGNMENT) {
                return p;
            }
        }
        return null;
    }

    self.sort = function () {
        self.list.sort(compare);
        function compare(a, b) {
            var compvala = a.studentLogin.Teacher.toLowerCase() + a.studentLogin.Team.toLowerCase() + a.projectName.toLowerCase();
            var compvalb = b.studentLogin.Teacher.toLowerCase() + b.studentLogin.Team.toLowerCase() + b.projectName.toLowerCase();
            if (compvala < compvalb)
                return -1;
            if (compvala > compvalb)
                return 1;
            return 0;
        }
    }
    self.save = function () {
       
        VR_Utility.save(self.list);
    }

    self.clearAll = function () {
        VR_Utility.clearLocal();
        self.list = [];
    }

    self.deleteProject = function (ASSIGNMENT) {
        //added this if because splice seemed to not work when length is 1
        if (self.list.length == 1) {
            self.list.pop();
            self.save();
        }
        else {
            for (var del in self.list) {
                if (self.list[del].assignmentId == ASSIGNMENT) {
                    self.list.splice(del, 1);
                    self.save();
                }
            }
        }
    }
    self.deleteMulti = function (idarray) {
        for (var i in idarray) {
            for (var j in self.list) {
                if (self.list[j].assignmentId == idarray[i]) {
                    self.deleteProject(idarray[i]);
                }
            }
        }
    }

    self.updateLogin = function (projId, assignment, newLogin) {
        var index = self.getProjIndexById(projId, assignment);
        var login = self.list[index].studentLogin;
        for (var proj in self.list) {
            if (self.
            list[proj].studentLogin.Teacher == login.Teacher && self.list[proj].studentLogin.Team == login.Team) {
                self.list[proj].studentLogin = newLogin;
            }
        }
    }

    self.updateAllSameLogins = function (currentLogin) {
        for (var i = self.length() - 1; i >= 0; i--) {
            var p = self.list[i];
            if (currentLogin.Teacher == p.studentLogin.Teacher
                && currentLogin.Team == p.studentLogin.Team) {
                p.studentLogin = currentLogin;
            }
        }
        //save locally
        self.save();
    }

}