﻿/// <reference path="External/jquery-1.11.2.min.js" />
/// <reference path="External/jquery-ui-1.11.4.min.js" />
/// <reference path="External/jquery.tmpl.min.js" />

function ProjectsViewModel() {
    var self = this,
        PROJECT_LIST_CONTAINER = $("#container-project-listing"),
        SPLASH_CONTAINER = $("#container-splash"),
        HELP_CONTAINER = $("#container-help"),

        //Modified by Shreya 22th Oct 2013; START
        COPYRIGHT_CONTAINER = $("#copyright"),
        //END
        PROJECT_CONTAINER = $("#container-tool").empty(),
        REPORT_CONTAINER = $("#report-placeholder").empty(),
        LEFT_TO_RIGHT = true,
        mainList,
        compareList,
        TEXT_BUBBLE = $("#text-bubble"),
        CANVAS,
        CONTEXT,
        lineWidth = 2,
        canvasPadding = 10,
        compareItems,
        colorArray;

    PROJECT_CONTAINER.on("click", "#back-button", function () {
        if (isDirty) {

            jConfirm(getRsc('rsc_1'), getRsc('rsc_2'), function (res) {
                if (res == true) {
                    //go back
                   
                    $("#tool-report").hide();
                    $(document).off("backbutton").on("backbutton", function () {
                        //override back button .. do nothing
                    });
                    //jsPlumb.removeEveryEndpoint(); // Win 8 conversion Changes By Guna , Date : 21-Nov-13 
                    jsPlumb.deleteEveryEndpoint(); //  Plugin upgrade required to change the method name
                    self.localLoad();
                }
                else {
                    //stay on page
                    //alert('Saving');
                }
            });
            $("#popup_message").css("font-size", "10px", "important");
        }
        else {
            $("#tool-report").hide();
            $(document).off('backbutton').on("backbutton", function () {
                //override back button .. do nothing
            });
            //jsPlumb.removeEveryEndpoint(); // Win 8 conversion Changes By Guna , Date : 21-Nov-13 
            jsPlumb.deleteEveryEndpoint();//  Plugin upgrade required to change the method name
            self.localLoad();
        }
    });

    TEXT_BUBBLE.find("#cancel-comment-button").click(function () { self.hideTextBubble(); });

    //main PROJECT LIST
    self.projectList = new ProjectList();

    self.listHeadMarkup = "${msg}";
    self.listMarkup = "<li class='projItem{{if isNew}} new{{/if}}' projId=${projectId} assignmentId=${assignmentId}>"
                        + " <div class='delete'>"
                        + "</div>"
                        + " <div class='info'><span class='project-name'>${projectName}</span>"
				        + " <br/>"
				        + " <span class='teacher-name'>${studentLogin.Teacher}</span>"
				        + " <span class='pipe'>|</span>"
				        + " <span class='team-name'>${studentLogin.Team}</span></div>"
                        + "</li>";

    $.template("projListHeadTemplate", self.listHeadMarkup);
    $.template("projListTemplate", self.listMarkup);
    $.template("itemTemplate", $("#item-tmpl").text());
    $.template("itemCompareTemplate", $("#item-compare-tmpl").text());
    $.template("teamsSelectTemplate", $("#teams-select-tmpl").text());
    $.template("commentTemplate", $("#comment-tmpl").text());
    $.template("projTemplate", $("#project-tmpl").text());
    $.template("reportTemplate", $("#report-tmpl").text());

    //click add/update projects button
    self.clientLogin = function (refreshLogin) {
        if (refreshLogin) {
            var currentLogin = new StudentLogin(refreshLogin.Teacher, refreshLogin.Team, refreshLogin.Password, true); //last element no longer needed remove from Student login later
        }
        else {
          
            var currentLogin = new StudentLogin($("#txt-teacher-id").val(), $("#txt-team-id").val(), $("#txt-password").val(), true); //last element no longer needed remove from Student login later
        }
        self.showLoading();
        listPassback = null;
        $(document).off('listLoadSuccess').on('listLoadSuccess', function (e) {
            var projectsFromLogin = listPassback;
            if (projectsFromLogin == null) {
                
                $('#invalid-login').show();
                $('#login-close-button').show();
                return;
            }

            $('#refresh-projects-button').parent().removeClass('disabled');
            self.projectList.update(currentLogin, projectsFromLogin);
            setPrefs(currentLogin);

            self.hideLoginPopup();
            self.hideLoading();
            self.bindListView();
        });
        currentLogin.getProjects();
    };

    self.downloadAssignmentById = function (projId, teamId) {
        var projToGet = self.projectList.getProjById(projId, teamId);
        //callback from project.load to allow async call / prevent spinner freeze
        tempProj = null;
        $(document).off('projLoadSuccess').on('projLoadSuccess', function (e) {
            var projDataRecieved = tempProj;
            if (projDataRecieved.studentLogin.isValid) {
                self.hideLoginPopup();
                var projObj = new Project(projDataRecieved);
                projObj.studentLogin = projToGet.studentLogin;
                projToGet.isNew = false;
                if (projToGet.studentLogin.isRetained) {
                    self.projectList.updateAllSameLogins(projDataRecieved.studentLogin);
                }
                projToGet.studentLogin = tempProj.studentLogin;
                self.projectList.save();
                self.bindProjectView(projObj);
            } else {
                self.hideLoading();
                self.showLoginPopup(projToGet.projectId, projToGet.studentLogin.Teacher, projToGet.studentLogin.Team, teamId);
            }
        });
        projToGet.load();
    };


    //function to draw the project list
    self.bindListView = function () {
        $('.intel-header').show();
        $('.die-strip').show();

        self.projectList.sort();
        $("#project-list-ul").empty();
        if (self.projectList.list.length == 0) {
            //you have no projects
            $("#project-list-heading-text").empty();
            var headNo = {};
            headNo.msg = getRsc('rsc_24'); //"You have no active projects";
            $.tmpl("projListHeadTemplate", headNo).appendTo("#project-list-heading-text");
        }
        else {
            //these are your active projects
            $("#project-list-heading-text").empty();
            var headNo = {};
            headNo.msg = getRsc('rsc_25'); //"These are your active projects";
            $.tmpl("projListHeadTemplate", headNo).appendTo("#project-list-heading-text");
            $.tmpl("projListTemplate", self.projectList.list).appendTo("#project-list-ul");
        }

        $('#select-all').removeAttr("checked");
        self.enableDelete();

        $('#select-all-parent').toggle(self.projectList.length() > 0);

        $(".projItem").click(function () {
            $('#spinner').show();
            var projToGet = self.projectList.getProjById($(this).attr('projId'), $(this).attr('assignmentId'));
            if (!projToGet.studentLogin.isRetained) {
                fromList = true;
                self.hideLoading();
                self.showLoginPopup(projToGet.projectId, projToGet.studentLogin.Teacher, projToGet.studentLogin.Team, projToGet.assignmentId);
            }
            else {
                if (!projToGet.studentLogin.isEncrypted) {
                    fromList = true;
                    self.hideLoading();
                    self.showLoginPopup(projToGet.projectId, projToGet.studentLogin.Teacher, projToGet.studentLogin.Team, projToGet.assignmentId);
                }
                else {
                    fromList = false;
                    self.downloadAssignmentById($(this).attr('projId'), $(this).attr('assignmentId'));
                }
            }
        });

        //change to delegate and move out of here
        $('.delete-checkbox').click(function (e) {
            e.stopPropagation();
            self.enableDelete();
            $(this).parent().parent().toggleClass("selected");
        });

        PROJECT_LIST_CONTAINER.show();
        //Modified by Shreya 22th Oct 2013; START
        COPYRIGHT_CONTAINER.show();
        //END
        $("body").addClass("project-listing");
        PROJECT_CONTAINER.empty();
        self.hideTextBubble();
    };

    self.bindProjectView = function (project) {
        $(document).off('click', '#project-object-refresh').on('click', '#project-object-refresh', function () {

            if (isDirty) {
                jConfirm(getRsc('rsc_3'), getRsc('rsc_4'), function (res) {
                    if (res == true) {
                        self.showLoading();
                        self.downloadAssignmentById(project.projectId, project.assignmentId);
                    }
                    else {

                    }
                });
                $("#popup_message").css("font-size", "11px", "important");
            }
            else {
                jConfirm(getRsc('rsc_5'), getRsc('rsc_6'), function (res) {
                    if (res == true) {
                        self.showLoading();
                        self.downloadAssignmentById(project.projectId, project.assignmentId);
                    }
                    else {

                    }
                });
            }
        });

        if (ENV == "android") {
            //handle the back button
            $(document).off("backbutton").on("backbutton", backKeyDown);

            function backKeyDown() {
                if (isDirty) {
                    jConfirm(getRsc('rsc_1'), getRsc('rsc_2'), function (res) {
                        if (res == true) {
                            //go back
                           
                            $("#tool-report").hide();
                            //jsPlumb.removeEveryEndpoint(); // Win 8 conversion Changes By Guna , Date : 21-Nov-13
                            jsPlumb.deleteEveryEndpoint();//  Plugin upgrade required to change the method name
                            self.localLoad();
                            $(document).off("backbutton").on("backbutton", function () {
                                //override back button .. do nothing
                            });
                        }
                        else {
                            //alert('staying on page');
                        }
                    });
                    $("#popup_message").css("font-size", "10px", "important");
                }
                else {
                    //go back
                    $("#tool-report").hide();
                    //jsPlumb.removeEveryEndpoint(); // Win 8 conversion Changes By Guna , Date : 21-Nov-13 
                    jsPlumb.deleteEveryEndpoint();//  Plugin upgrade required to change the method name
                    self.localLoad();
                    $(document).off("backbutton").on("backbutton", function () {
                        //override back button .. do nothing
                    });
                }
            }
        }


        project = new Project(project);
        isDirty = false;
        PROJECT_LIST_CONTAINER.hide();

        //Modified by Shreya 22th Oct 2013; START
        COPYRIGHT_CONTAINER.hide();
        //END

        $("body").removeClass("project-listing");
        $('.intel-header').hide();
        $('.die-strip').hide();

        PROJECT_CONTAINER.empty();
        $.tmpl("projTemplate", project).appendTo(PROJECT_CONTAINER);
        REPORT_CONTAINER.empty();
        $.tmpl("reportTemplate", project).appendTo(REPORT_CONTAINER);
        mainList = $("#main-list");
        compareList = $("#compare-list");
        compareList.empty().closest("div").removeClass("compare");

        //$("#comments").hide();
        $("#comments-close-container").hide();

        redraw();

        PROJECT_CONTAINER.off("click", "#save-button").on("click", "#save-button", function () {
            self.showLoading();
            project.save();
            isDirty = false;
            self.hideLoading();
        }).off("click", "#comments-open-container").on("click", "#comments-open-container", function () {
            $("#comments-open-container").hide();
            $("#comments-close-container").show();
            if ($("#comments").find('li').length != 0) {
                //--asp.
                $("#comments").find('ul').show();
                $("#comments").show();
            }
            redraw();
            //have to do it twice to propperly redraw on resize
            jsPlumb.repaintEverything();
            jsPlumb.repaintEverything();
            setItemTextSpan();
        }).off("click", "#comments-close-container").on("click", "#comments-close-container", function () {
            $("#comments-open-container").show();
            $("#comments-close-container").hide();
            //--asp.
            if ($("#comments").find('li').length != 0) {
                $("#comments").find('ul').hide();
            }
            //$("#comments-container").css("margin-bottom", "5px");
            $("#comments-container").attr('style', 'margin-bottom:1px !important');
            //--asp.
            $("#comments").hide(0, function () {
                redraw();
                //have to do it twice to propperly redraw on resize
                jsPlumb.repaintEverything();
                jsPlumb.repaintEverything();
                setItemTextSpan();
            });
        }).off("click", "#print-button").on("click", "#print-button", function () {
            //print section.. not implemented.
        }).off("click", "#report-button").on("click", "#report-button", function () {
            if ($("#tool-report").is(":visible")) {
                $("#tool-report").hide();

                //toggle the button to a back button
                $('#report-button').toggleClass('report-back');
                $('#report-button').toggleClass('report-normal');

                //container elements
                $("#comments-container").show();
                $("#tool").show();
                $("._jsPlumb_connector").show();

                //if there is a comparison active reshow the compare dropdown
                if ($('#compare-list').find('li').length != 0) {
                    $("#compare-teams-container").show();
                }

                //buttons
                $('#project-object-refresh').parent().show();
                $('#compare-button').parent().show();
                $('#save-button').parent().show();
                $('#back-button').parent().show();
                $('#exit-button-projlevel').parent().show();
                //hide help text for report button
                //$('#reportButtonInfo').hide();
                //trigger the info open
                $('#info-open-button').trigger('click');
                setTimeout(function () {
                    setItemTextSpan();
                }, 300);
            }
            else {
                $("#tool-report").show();

                //toggle the button to a back button
                $('#report-button').toggleClass('report-back');
                $('#report-button').toggleClass('report-normal');

                //container elements
                $("#comments-container").hide();
                $("#tool").hide();
                $("._jsPlumb_connector").hide();
                $("#compare-teams-container").hide();

                //buttons
                $('#project-object-refresh').parent().hide();
                $('#compare-button').parent().hide();
                $('#save-button').parent().hide();
                $('#back-button').parent().hide();
                $('#exit-button-projlevel').parent().hide();
                //show help text for report button
                //$('#reportButtonInfo').show();
                //trigger the info close
                $('#info-close-button').trigger('click');
            }
            redraw();
        }).off("click", "#add-comment-button").on("click", "#add-comment-button", function () {
            self.showCommentBubble();
        }).off("change", "#compare-teams").on("change", "#compare-teams", function () {
            redraw();
            //jsPlumb.removeEveryEndpoint(); // Win 8 conversion Changes By Guna , Date : 21-Nov-13 
            jsPlumb.deleteEveryEndpoint();//  Plugin upgrade required to change the method name
            jsPlumb.repaintEverything();

            var value = $(this).val();
            if (value == "-") {
                compareList.empty().closest("div").removeClass("compare");
                $(".correlation").hide();
            } else {
                var compareItems = self.getCompareItems(project, value);
                project.calculateCorrelation(compareItems);
                if (compareItems.length) {
                    compareList.empty().closest("div").addClass("compare");
                    $.tmpl("itemCompareTemplate", compareItems, { list: 'compare' }).appendTo("#compare-list");
                    redraw();
                    //jsPlumb.removeEveryEndpoint(); // Win 8 conversion Changes By Guna , Date : 21-Nov-13 
                    jsPlumb.deleteEveryEndpoint(); //  Plugin upgrade required to change the method name

                    mainList.find("li").each(function () {
                        var id = $(this).attr("id");
                        var color = $(this).css('background-color');
                        var inst = jsPlumb.connect({
                            source: id,
                            target: id.replace('main', 'compare'),
                            paintStyle: { strokeStyle: color, lineWidth: lineWidth },
                            endpoint: "Blank",
                            connectorPaintStyle: { strokeStyle: color, lineWidth: lineWidth },
                            connector: ["Straight"],
                            anchors: ["RightMiddle", "LeftMiddle"]
                        });

                        //jsPlumb.setDraggable($(this), "false");

                        //hack solution to color bug
                        var cl = $(this).attr('class');
                        //parse cl to remove comment class if there
                        if (cl.indexOf("comment") != -1) {
                            cl = cl.slice(0, cl.lastIndexOf("comment"));
                        }
                        $('#' + id.replace('main', 'compare')).removeClass().addClass(cl);
                    });
                    redraw();
                    setItemTextSpan();
                }
                else {
                    jAlert(getRsc('rsc_7'), getRsc('rsc_8'));
                    $("#popup_message").css("font-size", "13px", "important");
                    $('#compare-teams').val("-");
                    $('#compare-teams').trigger("change");
                    redraw();
                    setItemTextSpan();
                }
            }

        });

        //------------------------------------------------------------------------------------------------
        //------------------------------------------------------------------------------------------------
        //------------------------------------------------------------------------------------------------
        // android comment edit fix By Guna - 27-Nov-2013 -Start
       
       if (ENV == "android") {
           TEXT_BUBBLE.off("click", "#comment-textarea").on("click", "#comment-textarea", function () {

              $("#drag-comment").draggable("disable");
               $("#drag-comment").draggable({ opacity: 1 });

          });

            // android comment box dragging on edit mode fix By Vara - 02-Dec-2013 -Start
          //  TEXT_BUBBLE.off("focus", "#comment-textarea").on("focus", "#comment-textarea", function () {
                
             //  TEXT_BUBBLE.trigger('click');
              //  $(this).trigger('click');
             //   $(this).trigger('touchstart');
              //  $("#drag-comment").draggable({ opacity: 1 });

          // });
            //end

          TEXT_BUBBLE.off("blur", "#comment-textarea").on("blur", "#comment-textarea", function () {

               $("#drag-comment").draggable("enable");

           });
       }
        // comment edit fix By Guna - 27-Nov-2013 -Start
        TEXT_BUBBLE.off("click", "#save-comment-button").on("click", "#save-comment-button", function () {
            var bubbleItem = TEXT_BUBBLE.data('item');
            if (bubbleItem) {
                for (var i = 0, len = project.items.length; i < len; i++) {
                    if (project.items[i].itemId == bubbleItem.itemId) {
                        project.items[i].comment = $.trim(TEXT_BUBBLE.find("textarea").val()); //added for handling space in comment
                        if (project.items[i].comment) {
                            $(mainList.find('li')[i]).addClass('comment');
                        } else {
                            $(mainList.find('li')[i]).removeClass('comment');
                        }
                        break;
                    }
                }
            } else {
                
                var comment = TEXT_BUBBLE.data('comment');
                if (comment) {
                    var text =$.trim(TEXT_BUBBLE.find("textarea").val()); //added for handling space in comment
                    if (text) {
                        project.addComment(text);
                    } else {
                        jAlert(getRsc('rsc_9'), getRsc('rsc_10'));
                    }
                }
                else {
                    //alert("No data found!");
                }
            }
            REPORT_CONTAINER.empty();
            $.tmpl("reportTemplate", project).appendTo(REPORT_CONTAINER);
            self.hideTextBubble();
            isDirty = true;
        });

        //------------------------------------------------------------------------------------------------
        //------------------------------------------------------------------------------------------------
        //------------------------------------------------------------------------------------------------
        if (ENV == "android" || ENV == "ios" || ENV == "Windows") { //Win 8 conversion Changes By Guna , Date : 21-Nov-13
            var startTime, endTime;
            var gbMove = false;
            var mouseUp = false;

            //Modified by Shreya, 4-DEC-2013, 
            //Fix for wrong comment box opening on long press
            var thisClone;

            window.addEventListener('touchmove', function (event) {
                gbMove = true;
                thisClone = $(this);

            }, false);

            if (window.navigator.msPointerEnabled) { // Win 8 Defect # Mapp_VR_9 Fix By Guna, Date:24-dec-13 - Start
                mainList.find("li").on('MSPointerDown', function () {

                    startTime = new Date().getTime();
                    gbMove = false;
                    mouseUp = false;
                    thisClone = $(this);

                    var t = setTimeout(function () {
                        if (!gbMove && !mouseUp) {

                            //Modified by Vara, 27-NOV-2013, Shreya 28th NOV START
                            $("#drag-comment").css({
                                'width': '70%',
                                'margin': '20px auto 100% auto',
                                'top': '0px',
                            });
                            //END

                            self.showTextBubble(thisClone, true, true);
                        }
                    }, 100);
                }).on('touchend', function () {
                    mouseUp = true;
                    thisClone = $(this);
                });
            }
            else { // Win 8 Defect # Mapp_VR_9 Fix By Guna, Date:24-dec-13 - End
                mainList.find("li").on('touchstart', function () {

                    startTime = new Date().getTime();
                    gbMove = false;
                    mouseUp = false;
                    thisClone = $(this);

                    var t = setTimeout(function () {
                        if (!gbMove && !mouseUp) {

                            //Modified by Vara, 27-NOV-2013, Shreya 28th NOV START
                            $("#drag-comment").css({
                                'width': '70%',
                                'margin': '20px auto 100% auto',
                                'top': '0px',
                            });
                            //END

                            self.showTextBubble(thisClone, true, true);
                        }
                    }, 700);
                }).on('touchend', function () {
                    mouseUp = true;
                    thisClone = $(this);
                });
            }
            //Modified by Shreya, 18-NOV-2013, START
            //Req.1.5 “Right Swipe” for comment update
            //mainList.find("li").swipe({
            //    swipeRight: function (event, direction, distance, duration, fingerCount) {

            //        $("#drag-comment").css({
            //            'width': '50%',
            //            'left': '25%',
            //            'right': '25%',
            //            'top': '0px',
            //        });

            //        self.showTextBubble($(this), true, true);
            //    }
            //});
            //END
        }

        if (ENV == "android" || ENV == "Windows") { //Win 8 conversion Changes By Guna , Date : 21-Nov-13
            mainList.sortable({
                //containment: '#main-list',  //'#container-tool',
                //connectWith: mainList,
                axis: 'y',
                revert: '200',
                tolerance: 'pointer',
                //implement fix for long press
                distance: '20',
                delay: '200',
                start: function (event, ui) {
                    ui.placeholder.height(ui.item.height());
                    isDirty = true;
                    self.hideTextBubble();
                    $('._jsPlumb_connector').hide();

                },
                stop: function (event, ui) {
                    project.updateItemOrder();
                    var compval = $('#compare-teams').val();
                    if (compval) {
                        var compareItems = self.getCompareItems(project, compval);
                        project.calculateCorrelation(compareItems);
                    }
                    REPORT_CONTAINER.empty();
                    $.tmpl("reportTemplate", project).appendTo(REPORT_CONTAINER);
                    isDirty = true;
                    jsPlumb.repaintEverything();
                    $('._jsPlumb_connector').show();
                },
            }).find("li").dblclick(function () {
                //modified by vara: 21- nov-2013 adding for req-1.1 ; Shreya 28th NOV-start
                $("#drag-comment").css({
                    'width': '70%',
                    'margin': '20px auto 100% auto',
                    'top': '0px',
                });
                //end
                self.showTextBubble($(this), true, true);
            });
            //Modified by Shreya, 18-NOV-2013, START
            //Req.1.5 “Right Swipe” for comment update
            //mainList.find("li").swipe({
            //    swipeRight: function (event, direction, distance, duration, fingerCount) {

            //        $("#drag-comment").css({
            //            'width': '50%',
            //            'left': '25%',
            //            'right': '25%',
            //            'top': '0px',
            //        });

            //        self.showTextBubble($(this), true, true);
            //    }
            //});
            //END
        }
        else {
            mainList.sortable({
                containment: '#tool',
                distance: '25',
                axis: 'y',
                revert: '250',
                scroll: 'false',
                tolerance: 'pointer',
                start: function (event, ui) {
                    ui.placeholder.height(ui.item.height());
                    isDirty = true;
                    self.hideTextBubble();
                },
                stop: function (event, ui) {
                    project.updateItemOrder();
                    var compval = $('#compare-teams').val();
                    if (compval) {
                        var compareItems = self.getCompareItems(project, compval);
                        project.calculateCorrelation(compareItems);
                    }
                    REPORT_CONTAINER.empty();
                    $.tmpl("reportTemplate", project).appendTo(REPORT_CONTAINER);
                    isDirty = true;
                    jsPlumb.repaintEverything();
                    redraw();
                },
                sort: function (event, ui) {
                    jsPlumb.repaintEverything();
                }
            }).find("li").dblclick(function () {
                //modified by vara: 21- nov-2013 adding for req-1.1 ; Shreya 28th NOV-start
                $("#drag-comment").css({
                    'width': '70%',
                    'margin': '20px auto 100% auto',
                    'top': '0px',
                });
                //end
                self.showTextBubble($(this), true, true);
            });


            //Modified by Shreya, 18-NOV-2013, START
            //Req.1.5 “Right Swipe” for comment update
            //mainList.find("li").swipe({
            //    swipeRight: function (event, direction, distance, duration, fingerCount) {

            //        $("#drag-comment").css({
            //            'width': '50%',
            //            'left': '25%',
            //            'right': '25%',
            //            'top': '0px',
            //        });

            //        self.showTextBubble($(this), true, true);
            //    }
            //});
            //END
        }

        self.hideLoading();
        setTimeout(function () {
            setItemTextSpan();
        }, 250);
        setTimeout(function () {
            setItemTextSpan();
        }, 500);
    };              //---------------------------end of bindProjectView------------------------------


    self.getCompareItems = function (project, compareTo) {
        var res = project.getItemsOrder(compareTo),
                        compareItems = [];
        if (res) {
            for (var i = 0, len = res.length; i < len; i++) {
                var item = findById(project.items, 'itemId', res[i].itemId);
                if (item) {
                    compareItems.push(new Item(item, res[i]));
                }
            }
        }
        //project.calculateCorrelation(compareItems);
        return compareItems;
    };

    self.hideTextBubble = function () {
        TEXT_BUBBLE.removeData();
        TEXT_BUBBLE.stop();
        TEXT_BUBBLE.hide();
    };


    self.showCommentBubble = function () {
        TEXT_BUBBLE.removeData();
        //removed to force comments bubble to top of screen
        //TEXT_BUBBLE.find("form").css('margin-top', "50%");
        TEXT_BUBBLE.data('comment', true);
        TEXT_BUBBLE.find("textarea").val('');
        TEXT_BUBBLE.find("form").show();
        TEXT_BUBBLE.stop();
        TEXT_BUBBLE.fadeTo(500, 1);
        TEXT_BUBBLE.find("textarea").focus();
        //TEXT_BUBBLE.find("textarea").focus(function () {
        //    alert("hi0");
        //    TEXT_BUBBLE.find("textarea").focus();
        //});
      
    }
   
    self.showTextBubble = function (listElement, isEditable, isMainList) {
        var contents = "",
            itemID = listElement.attr('id');
        var bgcolor = listElement.css('background-color');
        var item = listElement.tmplItem().data; //findById(self.items, "itemId", itemID);
        mainListBubble = isMainList;

        currentID = itemID;
        //TEXT_BUBBLE.find("form").css('margin-top', listElement.position().top);
        //TEXT_BUBBLE.css('top', listElement.position().top);

        // copy the item border color
        //TEXT_BUBBLE.find("form").css('border-color', bgcolor);
        //Modified by vara,date:27 sept 2013, Adding for dragging the comment box start
      
        TEXT_BUBBLE.find('#drag-comment').css({ "background-color": bgcolor });
       //$("#comment-textarea").focus();
       
        //end-->

        TEXT_BUBBLE.data('item', item);
        contents = item.comment || '';

        //        if (isMainList) {
        //           

        //            //            if (LEFT_TO_RIGHT) {
        //            //                TEXT_BUBBLE.css('left', listElement.position().left + listElement.outerWidth() + 5);
        //            //            }
        //            //            else {
        //            //                TEXT_BUBBLE.css('left', listElement.position().left - TEXT_BUBBLE.outerWidth() - 5);
        //            //            }
        //        }
        //        else {
        //            index = indexCompareLookup[itemID];
        //            contents = compareItemsData.items[index].comment;

        //            //            if (LEFT_TO_RIGHT) {
        //            //                TEXT_BUBBLE.css('left', listElement.position().left - TEXT_BUBBLE.outerWidth() - 5);
        //            //            }
        //            //            else {
        //            //                TEXT_BUBBLE.css('left', listElement.position().left + listElement.outerWidth() + 5);
        //            //            }
        //        }

        TEXT_BUBBLE.find('p').empty();

        if (!isEditable) {
            contents = contents.split("\n").join("<br/>");
            contents = contents.split("\r").join("<br/>");
            TEXT_BUBBLE.append('<p>' + contents + '</p>');
            TEXT_BUBBLE.find("form").hide();
        }
        else {
            contents = contents.split("&apos;").join("'");
            contents = contents.split("&quot;").join("\"");
            contents = contents.split("<br/>").join("\n");
            //TEXT_BUBBLE.find("textarea").focus(function () {alert("focused") });
            TEXT_BUBBLE.find("textarea").val(contents);
            TEXT_BUBBLE.find("form").show();
           
            TEXT_BUBBLE.find("textarea").focus();
            //TEXT_BUBBLE.find("textarea").focus(function () {
            //    alert("hi1");
            //    TEXT_BUBBLE.find("textarea").focus();
            //});
           // $('#comment-textarea').focus();
            //TEXT_BUBBLE.find("textarea").focus(); //Added for issue - keyboard doesn't appear for comment box in Android V3.
           
            commentFormMode = true;
        }

        var showBubble = true;

        //        if (!TOUCH_MODE) {
        //            showBubble = true;
        //        }
        //        else {
        //            // show bubbles from the main list regardless
        //            if (isMainList) {
        //                showBubble = true;
        //            }
        //            // don't show if on the compare list and empty content
        //            else if (contents != null && contents != "") {
        //                showBubble = true;
        //            }
        //            // hide the text bubble
        //            else {
        //                showBubble = false;
        //            }
        //        }

        if (showBubble) {
            TEXT_BUBBLE.stop();
            TEXT_BUBBLE.fadeTo(500, 1);
            TEXT_BUBBLE.find("textarea").focus();
            //TEXT_BUBBLE.find("textarea").focus(function () {
            //    alert("hi2");
            //    TEXT_BUBBLE.find("textarea").focus();
            //});
           
            
           
        }
        else {
            currentID = "";
            TEXT_BUBBLE.stop();
            TEXT_BUBBLE.hide();
            //commentFormMode = false;
        }
       
        
    };

    //redundant now with JSPlumbs inclusion
    self.clearCanvas = function () {
        var canvasWidth = $(CANVAS).width(),
            canvasHeight = $(CANVAS).height();

        CONTEXT.clearRect(0, 0, canvasWidth, canvasHeight);
        //print_context.clearRect(0, 0, canvasWidth, canvasHeight);
    };

    self.getItemLineData = function ($list) {
        var itemDataArray = [];
        $list.find('li').each(function () {
            var id = $(this).attr('id');
            var itemData = {}

            // work out y positions
            itemData.pos = $(this).position().top + $(this).outerHeight() / 2 + lineWidth / 2;

            // set border color
            itemData.color = $(this).css('background-color');
            itemDataArray[id] = itemData;
        });

        return itemDataArray;
    };

    $("#help-button").click(function () {
        $('#student-button').addClass('selected');
        $('#parent-button').removeClass('selected');

        $('#help-student').show();
        $('#help-parent').hide();

        $('#parent-button').click(function () {
            $(this).addClass('selected');
            $('#student-button').removeClass('selected');
            $('#help-student').hide();
            $('#help-parent').show();
        });
        $('#student-button').click(function () {
            $(this).addClass('selected');
            $('#parent-button').removeClass('selected');
            $('#help-parent').hide();
            $('#help-student').show();
        });

        self.toggleHelp();
    });

    //-----------------------------------------------------------------------------------
    //------------------------------------show login-------------------------------------
    //-----------------------------------------------------------------------------------

    $("#add-project-button").click(function () {
        if (!($(this).parent().hasClass('disabled'))) {
            self.showLoginPopup();
        }
    });
    /*siva */
    
    $('#login').on("click", function () {
        

       // $('input').on("click", function () {

          if ((ENV == "android") && ($(window).height() < 601)) {
                var activeelmt = $(document.activeElement).attr("id");

                if (activeelmt == "txt-teacher-id") {

                    $(".dialog").css({ top: "-90px", position: "relative" });
                    // $('#txt-teacher-id').off("focus");
                }
                else if (activeelmt == "txt-team-id") {

                    $(".dialog").css({ top: "-130px", position: "relative" });
                    //alert("ram");
                    //  $('#txt-team-id').off("focus");

                }
                else if (activeelmt == "txt-password") {

                    $(".dialog").css({ top: "-190px", position: "relative" });
                    // $('#txt-password').off("focus");
                }
                else {
                    $(".dialog").css({ top: "0px", position: "relative" });
                }

                // alert("1 :"+activeelmt);
           }
       

    });
    
    /* siva */
    $("#refresh-projects-button").click(function () {
        if (!($(this).parent().hasClass('disabled'))) {
            self.clientLogin(getPrefs());
        }
    });

    $('#exit-button').click(function () {
        exitApp();
    });
   
    self.showLoginPopup = function (projId, teacher, team, assignment) {
        $("#txt-teacher-id").val("");
        $("#txt-team-id").val("");
        $("#txt-password").val("");
       
        $('#invalid-login').hide();
        $('#unsaved-login').hide();

        if (teacher == "" || teacher == null) {
            $("#login-button").click(function () {
                self.clientLogin();
            });
        }

        $("#login").show();
        //added for setting focus on login popup visible for IOS focus issue.
        // // if (ENV == "ios") {
        $("#txt-teacher-id").focus();
        //}
        //End focus
        COPYRIGHT_CONTAINER.show();
    }    

    //-----------------------------------------------------------------------------------
    //------------------------------------hide login-------------------------------------
    //-----------------------------------------------------------------------------------
    $("#login-close-button").click(function () {
        self.hideLoginPopup();
        //--asp.
        $("#tool-report").hide();
        jsPlumb.deleteEveryEndpoint(); // new JSPlumb method
        p.bindListView();
        $('#refresh-projects-button').parent().addClass('disabled');
        $('#project-list-heading-text').empty();
        $('#project-list').find('ul').empty();
        p.showSplash();
    });

    self.hideLoginPopup = function () {
        $("#login").hide();
    };

    //show hide loading spinners
    self.showLoading = function () {
        $('#spinner').show();
    };

    //show hide loading spinners
    self.hideLoading = function () {
        $('#spinner').hide();
    };

    //-----------------------------------------------------------------------------------
    //----------------------------------utility access-----------------------------------
    //-----------------------------------------------------------------------------------

    self.localLoad = function () {
        self.showLoading();
        var loaded = VR_Utility.load();

        if (loaded == null) {
            //no local data, show login
            
            self.showLoginPopup();
        }
        else {
            //clear any existing and load populate from restored
            self.projectList = new ProjectList()
            self.projectList.load(loaded);
            self.bindListView();
        }
        self.hideLoading();
    }

    self.clearLocalSave = function () {
        self.projectList.clearAll();
        self.bindListView();
    }

    // applies selected states and enables/disables delete button
    self.enableDelete = function () {
        $('#delete-projects').parent().toggleClass('enabled', $('input[name="delCheck"]:checked').length > 0);
        $('#delete-projects').parent().toggleClass('disabled', $('input[name="delCheck"]:checked').length == 0);
    }

    $('#delete-projects').click(function () {
        if ($('input[name="delCheck"]:checked').length > 0) {

            jConfirm(getRsc('rsc_11'), getRsc('rsc_12'), function (res) {
                if (res == true) {
                    var deleteIds = new Array();
                    var n = $('input[name="delCheck"]:checked').each(function () {
                        //$(this).parent().parent().hide();
                        deleteIds.push($(this).parent().parent().attr('assignmentId'));
                    });
                    self.projectList.deleteMulti(deleteIds);
                }
                self.bindListView();
            });
        }
    });

    $('#select-all').click(function () {
        var status = $(this).prop('checked');
        $('input[name="delCheck"]').each(function () {
            $(this).attr("checked", status);
        });
        self.enableDelete();
    });

    //if nothing in the list, hide the select all box
    if (self.projectList.length() == 0) {
        $('#select-all-parent').hide();
    }
    else {
        $('#select-all-parent').show();
    }

    self.showSplash = function () {

        $('#container-project-listing').find('.header').hide();

        $('#splash-continue-button').on('click', function () {
            $('#container-project-listing').find('.header').show();
            SPLASH_CONTAINER.hide();
            //Modified by Shreya 25th Nov 2013; START
            COPYRIGHT_CONTAINER.hide();
            //END
            self.showLoginPopup();
        });
        SPLASH_CONTAINER.show();
        //Modified by Shreya 25th Nov 2013; START
        COPYRIGHT_CONTAINER.show();
        //END
    }

    self.toggleHelp = function () {
        HELP_CONTAINER.toggle();
        $('#project-list').toggle();
        //Modified by Shreya 25th Nov 2013; START
        //COPYRIGHT_CONTAINER.hide();
        //END

        $('#add-project-button').parent().toggle();
        $('#refresh-projects-button').parent().toggle();

        //change the button to look like the back button
        $('#help-button').toggleClass('help-back');
        $('#help-button').toggleClass('help-normal');

        $('#exit-button').parent().toggle();

        var helpClass = $('#help-button').hasClass('help-back');
        if (helpClass) {
            COPYRIGHT_CONTAINER.hide();
        }
        else {
                COPYRIGHT_CONTAINER.show();
        }

    }


    //Entrypoint: init and begin application
    HELP_CONTAINER.hide();
    //$('#login-close-button').hide();
    $('#refresh-projects-button').parent().addClass('disabled');
    VR_Utility.clearLocal();
    self.showSplash();
    //call initial loading from saved data


    $(document).on('input paste', '#comment-textarea', function () {
        var tobj = $('#comment-textarea');
        var tlen = tobj.attr('maxlength');
        checkMaxLen(tobj, tlen);
    });

    //-------------------------------end-utility access----------------------------------
    //-----------------------------------------------------------------------------------
}
//initialize the view model
//Win 8 conversion Changes By Guna , Date : 21-Nov-13 -Start
if (ENV == "Windows") {
    MSApp.execUnsafeLocalFunction(function () {
        p = new ProjectsViewModel();
    });
}
else {
    p = new ProjectsViewModel();
}
var p;
//Win 8 conversion Changes By Guna -End



