﻿$(document).ready(function () {
    //setup versioning
    if (ENV == "air") {
        //air handler for window close event
        window.nativeWindow.addEventListener(air.Event.CLOSING, cleanup);
        function cleanup(event) {
            event.preventDefault();
            if (isDirty) {
                jConfirm(getRsc('rsc_16'), getRsc('rsc_17'), function (res) {
                    if (res == true) {
                        window.close();
                    }
                    else {
                        //alert('Saving');
                    }
                });
            }
            else {
                window.close();
            }
        }

        //redraw on window size change
        window.nativeWindow.addEventListener(air.Event.RESIZE, bleep);
        function bleep(event) {
            //air.Introspector.Console.log(nativeWindow.width);
            redraw();
            setTimeout(function () {
                jsPlumb.repaintEverything();
            }, 0);
        }
    }

    //call for web resize, duplicated in AIR, but double redraw is needed
    //because air event handler is slow with window size update on maximize

    window.onorientationchange = function () {
        jsPlumb.repaintEverything();
    };

    $(window).resize(function () {
        if ($('#login').length) {
            $('#login').height($(document).height());
        }
        redraw();
        jsPlumb.repaintEverything();
        jsPlumb.repaintEverything();
        setItemTextSpan();
    });
  
    p.hideLoading();
        $('#tool-report').hide();
        $('#login').height($(document).height());
        $('#login').height($(window).height());


        $("#container-tool").off("click", "#compare-button").on("click", "#compare-button", function () {
            if (!$("#compare-teams-container").toggle().is(":visible")) {
                $("#compare-list").empty().closest("div").removeClass("compare");
                $("#compare-teams").val("-");
                $(".correlation").hide();
            }
            //Win 8 conversion Changes By Guna , Date : 21-Nov-13 -Start
            if (ENV == "Windows") {
                MSApp.execUnsafeLocalFunction(function () {
                    $('#compare-teams').chosen({ disable_search: true });
                });
            }
            else {
                $('#compare-teams').chosen({ disable_search: true });
            }
            //Win 8 conversion Changes By Guna , Date : 21-Nov-13 -End
            //jsPlumb.removeEveryEndpoint(); // Win 8 conversion Changes By Guna , Date : 21-Nov-13
            jsPlumb.deleteEveryEndpoint();//  Plugin upgrade required to change the method name
            jsPlumb.repaintEverything();
            redraw();
            setItemTextSpan();
            /*Defect # K12VR_42,K12VR_47 fix By Guna - 02-Dec-13*/
            if (ENV == "Windows") {
                $("#compare_teams_chzn").css("top", "6px");
                $("#compare-teams-container label").css("margin", "0 0 5px 0");
                $("#compare-teams-container select").css("margin", "0 2px 5px 0");
                //$("#compare-teams-container span").css("margin", "0 2px 5px 0");
            }
            //end 

        }).off("click", "#info-open-button").on("click", "#info-open-button", function () {
            $(this).closest("span").hide().next().css("display", "inline-block");
            $(this).closest("div.header").find(".info").show();
            redraw();
            jsPlumb.repaintEverything();
            jsPlumb.repaintEverything();
        }).off("click", "#info-close-button").on("click", "#info-close-button", function () {
            $(this).closest("span").hide().prev().css("display", "inline-block");
            $(this).closest("div.header").find(".info").hide();
            redraw();
            jsPlumb.repaintEverything();
            jsPlumb.repaintEverything();
        }).off('click', '#exit-button-projlevel').on('click', '#exit-button-projlevel', function () {
            exitApp();
        });
        redraw();
        setItemTextSpan();

    jsPlumb.importDefaults({
        Endpoint: 'Blank',
        Connector: "Straight",
        Anchors: ["RightMiddle", "LeftMiddle"],
        DragOptions: { cursor: "pointer", zIndex: 2 },
        DropOptions: { cursor: "pointer", zIndex: 2 },
        HoverClass: "connector-hover",
        Draggable: "false",
        ConnectorZIndex: 2,

        //this was the eventual fix to jittery movement in jqueryui sortable, the endpoints although hidden
        //were attaching externally to the li elements overflowing the containment
        Container: $("#container-tool")
    });
    
        jsPlumb.setRenderMode(jsPlumb.SVG);
    
    });


function exitApp() {
    if (isDirty) {
        if (ENV == "ios") {
            //exit dialog for IOS
            $("#popup_message").css("font-size", "11px", "important");  // added for defect #43
            jConfirm(getRsc('rsc_19'), getRsc('rsc_20'), function (res) {
                handleExitDialog(res);
            });
            $("#popup_message").css("font-size", "12px", "important");
            $("#popup_message").css("padding-left", "46px", "important");
        }
        else {
            //exit dialog for android and air
            jConfirm(getRsc('rsc_16'), getRsc('rsc_17'), function (res) {
                handleExitDialog(res);
            });
        }
    }
    else {
        if (ENV == "ios") {
            //exit dialog for IOS
            jConfirm(getRsc('rsc_21'), getRsc('rsc_20'), function (res) {
                handleExitDialog(res);
            });
        }
        else {
            //exit dialog for android and air
            jConfirm(getRsc('rsc_18'), getRsc('rsc_17'), function (res) {
                handleExitDialog(res);
            });
        }
    }
}

function handleExitDialog(res) {
    if (res == true) {
        if (ENV == "air") {
            window.close();
        }
        if (ENV == "android") {
            navigator.app.exitApp();
        }
        if (ENV == "ios" || ENV == "Windows") { //Win 8 conversion Changes By Guna , Date : 21-Nov-13 
            //handle ios exit or suspend
            VR_Utility.clearLocal();
            $("#tool-report").hide();
            //jsPlumb.removeEveryEndpoint(); // Win 8 conversion Changes By Guna , Date : 21-Nov-13
            jsPlumb.deleteEveryEndpoint(); // new JSPlumb method
            p.bindListView();
            $('#refresh-projects-button').parent().addClass('disabled');
            $('#project-list-heading-text').empty();
            $('#project-list').find('ul').empty();
            p.showSplash();
        }
    }
    else {
        //alert('Saving');
    }
}

function setItemTextSpan(){

    $('#tool li').each(function () {
        var w = $(this).width() - $(this).find('img').width() - 35;
        $(this).find('.center-vert-outer').css({ 'max-width': w, 'width': w });
        var g = $(this).height();
        $(this).height((g > 100) ? 100 : g);
    });

    var new_height = $('#tool li').height();
    if ($('.center-vert-inner div').length > 0) {
        $('.center-vert-inner div').dotdotdot({
            wrap: 'letter',
            after: null,
            watch: true,
            height: new_height
        });
    }

    /*
    console.log('-----------------setItemTextSpan--------------');
    var mainH = $('#tool li').height();
    //var mainW = $('#tool li').width();

    $('#tool li').each(function (index) {
        console.log('li:' + index);
        var paraText = $(this).find('.show_overflow');
        var hiddenText = $(this).find('.hide_overflow');
        var divh = mainH - 5; //$(this).find('.center-vert-outer').height();
        //var divw = $(this).find('.center-vert-outer').width();

        //console.log(divh + '---' + divw);

        if (paraText.outerHeight(true) > divh) {
            console.log("BIGGER");
            while (paraText.outerHeight(true) >= divh) {
                paraText.text(function (index, text) {
                    var ttt = text.replace(/\W*\s(\S)*$/, '...');
                    return ttt;
                });
            }
            paraText.addClass('has_ellipsis');
        }
      
        else {
            //in case it has enlarged
            //replace with full text and reapply ellipsis if necessary
            paraText.text(hiddenText.text());
            while (paraText.outerHeight(true) >= divh) {
                paraText.text(function (index, text) {
                    var ttt = text.replace(/\W*\s(\S)*$/, '...');
                    return ttt;
                });
            }
        }
    });
    */
}

function redraw() {
    if ($('#compare-teams-container').is(":visible")) {
        var compareContainerHeight = $('#compare-teams-container').outerHeight();
    }
    else {
        var compareContainerHeight = 0;
    }
    var h = $(window).height() - $('#container-tool .header').outerHeight() - $('#comments-container').outerHeight() - compareContainerHeight -6;
    $('#tool').css("min-height", h); //.height(h);
    if ($("#main-list").find("li").length) {
        InitItemList($("#main-list"), $("#main-list").find("li").length);
    }
    if ($("#compare-list").find("li").length) {
        InitItemList($("#compare-list"), $("#compare-list").find("li").length);
    }
    $('#tool').css("min-height", $('#main-list').height());
}

function InitItemList($list, itemcount) {
    if (itemcount) {
        //var listheight = $list.closest('div').outerHeight();
        var listheight = $list.parent().outerHeight();
        listheight -= (itemcount + 1) * 8;
        var liheight = listheight / itemcount;
        //liheight = liheight > 100 ? 100 : liheight < 30 ? 30 : liheight;
        $list.find("li").css("height", liheight).css("line-height", (liheight-3) + "px");
    }
}

function parseDate(jsonDate) {
    if (jsonDate == " ") {
        return jsonDate;
    }
    else {
        var d;
        if (typeof (jsonDate) == 'string') {
            d = new Date(parseInt(jsonDate.substr(6)));
        } else {
            d = jsonDate;
        }
        return (d.toLocaleDateString() + " - " + d.toLocaleTimeString());
    }
}

function findById(source, key, id) {
    for (var i = 0; i < source.length; i++) {
        if (source[i][key] === id) {
            return source[i];
        }
    }
    return null;
}

//enforce and alert max length of input box
function checkMaxLen(Obj, Objmax) {
    //var maxnum = Obj.value.length;
    if (Obj.val().length >= Objmax) {
        jAlert(getRsc('rsc_22'), getRsc('rsc_23'));
        Obj.value = Obj.val().substring(0, Objmax-1);
    }
}

function navigateExternal(navURL) {
    //if (ENV == 'ios' || ENV == 'android' || ENV == 'Windows') { //Win 8 conversion Changes By Guna , Date : 21-Nov-13
    //    window.plugins.childBrowser.showWebPage(navURL, { showLocationBar: true });
    //}
    //else {
    //    window.open(navURL, '_blank');
    //}
    
    window.open(navURL, '_blank', 'EnableViewPortScale=yes');
   
}

// Localization alert message parameter assignment By Guna -Start
$.alerts.okButton = '&nbsp;' + getRsc('rsc_ok') + '&nbsp;';
$.alerts.cancelButton = '&nbsp;' + getRsc('rsc_cancel') + '&nbsp;';
//End

// Modified by vara,date:27 sept 2013, Adding for dragging the comment box start
$(function () {
    $("#drag-comment").draggable({ cancel: "text" }); // win 8 fix revert By Guna - 04-dec-13
});

//IOS text edit fix - By Vara
$(document).on("click", "#comment-textarea", function () {$(this).focus(); });
$(document).on("focus", "#comment-textarea", function () {
  
    //  window.plugins.SoftKeyBoard.show(function () { 
    //}); 
   
    var endIndex = $(this).val().length;
   if (this.setSelectionRange)
        this.setSelectionRange(endIndex, endIndex);
}
    );


//end
